Index: trunk/src/lib/collision_reaction/collision_handle.cc
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.cc	(revision 7841)
+++ trunk/src/lib/collision_reaction/collision_handle.cc	(revision 7841)
@@ -0,0 +1,39 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patirick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_REACTION
+
+#include "collision_handle.h"
+
+using namespace std;
+
+
+/**
+ * standard constructor
+ * @todo this constructor is not jet implemented - do it
+*/
+CollisionHandle::CollisionHandle ()
+{
+   this->setClassID(CL_COLLISION_HANDLE, "CollisionHandle");
+
+}
+
+
+/**
+ * standard deconstructor
+*/
+CollisionHandle::~CollisionHandle ()
+{
+  // delete what has to be deleted here
+}
Index: trunk/src/lib/collision_reaction/collision_handle.h
===================================================================
--- trunk/src/lib/collision_reaction/collision_handle.h	(revision 7841)
+++ trunk/src/lib/collision_reaction/collision_handle.h	(revision 7841)
@@ -0,0 +1,37 @@
+/*!
+ * @file collision_handle.h
+ * @brief Definition of a collision handle: used for accesing per world entity collision events and reactions
+*/
+
+#ifndef _COLLISION_HANDLE_H
+#define _COLLISION_HANDLE_H
+
+#include "base_object.h"
+
+class Collision;
+
+//! A class for defining collision reactions and storing events
+class CollisionHandle : public BaseObject {
+
+ public:
+  CollisionHandle();
+  virtual ~CollisionHandle();
+
+  void registerCollision(Collision* collision);
+
+  void handleCollisions();
+
+
+ private:
+   WorldEntity*                  owner;                   //!< the worldenity this reaction will be applied on
+   classID                       targetClass;             //!< the entities triggering the handle
+
+   bool                          bDispatched;             //!< true if this handle has already been dispatched
+   bool                          bStopOnFirstCollision    //!< true if the cd of this object should be terminated after one match
+
+   std::vector<Collision*>       collisionList;           //!< a list full of collisions
+   std::vector<classID>          targetList;              //!< a list of target classes for filtering
+
+};
+
+#endif /* _COLLISION_HANDLE_H */
Index: trunk/src/lib/collision_reaction/cr_engine.cc
===================================================================
--- trunk/src/lib/collision_reaction/cr_engine.cc	(revision 7840)
+++ trunk/src/lib/collision_reaction/cr_engine.cc	(revision 7841)
@@ -43,2 +43,18 @@
   CREngine::singletonRef = NULL;
 }
+
+
+
+CollisionHandle* CREngine::subscribeReaction(WorldEntity* worldEntity, CRType type, int nrOfTargets, ...)
+{
+#if 0
+  va_list itemlist;
+  va_start (itemlist, type);
+  for (int i = 0; i < faceElemCount; i++)
+    this->targetList.push_back(va_arg(itemlist, int));
+  va_end(itemlist);
+#endif
+}
+
+
+
Index: trunk/src/lib/collision_reaction/cr_engine.h
===================================================================
--- trunk/src/lib/collision_reaction/cr_engine.h	(revision 7840)
+++ trunk/src/lib/collision_reaction/cr_engine.h	(revision 7841)
@@ -36,10 +36,12 @@
   inline static CREngine* getInstance(void) { if (!singletonRef) singletonRef = new CREngine();  return singletonRef; };
 
-
-  CollisionHandle* subscribeReaction(WorldEntity* worldEntity, ClassId targets, CRType type);
+#if 0
+  CollisionHandle* subscribeReaction(WorldEntity* worldEntity, CRType type, int nrOfTargets, ...);
 
   bool unsubscribeReaction(WorldEntity* worldEntity);
   bool unsubscribeReaction(CollisionHandle* collisionHandle);
 
+
+  void handleCollisions();
 
   /** @returns an instance to a collision object. instead of creating new object this ones can be resycled */
@@ -55,4 +57,5 @@
   std::vector<CollisionHandle*>       collisionHandles;         //!< list with the collision handles
   std::vector<Collision*>             cachedCollisions;         //!< a list of unused, cached collision events
+#endif
 };
 