Index: code/trunk/data/levels/fightInOurBack.oxw
===================================================================
--- code/trunk/data/levels/fightInOurBack.oxw	(revision 7801)
+++ code/trunk/data/levels/fightInOurBack.oxw	(revision 7845)
@@ -54,5 +54,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettings3.oxi")
+  include("includes/weaponSettingsAssff.oxi")
 ?>
   </SpaceShip>
Index: code/trunk/data/levels/includes/weaponSettings1.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettings1.oxi	(revision 7801)
+++ 	(revision )
@@ -1,39 +1,0 @@
-    <weaponslots>
-      <WeaponSlot position="-15,-1.5,-25" yaw=0 pitch=0 roll=0 />
-      <WeaponSlot position="15,-1.5,-25" yaw=0 pitch=0 roll=0 />
-      <WeaponSlot position="0,0,-45" yaw=0 pitch=0 roll=0 />
-    </weaponslots>
-    <weaponsets>
-      <WeaponSet firemode=0 />
-      <WeaponSet firemode=1 />
-    </weaponsets>
-    <weapons>
-      <WeaponPack firemode=0>
-        <LaserGun
-            position="0,0,0"
-            munitionType="LaserGunMunition"
-            bulletLoadingTime="0.2"
-            magazineLoadingTime="5.0"
-            speed="1250"
-            unlimitedMunition=true
-        />
-        <LaserGun
-            position="0,0,0"
-            munitionType="LaserGunMunition"
-            bulletLoadingTime="0.2"
-            magazineLoadingTime="5.0"
-            speed="1250"
-            unlimitedMunition=true
-        />
-      </WeaponPack>
-      <WeaponPack firemode=1>
-        <Fusion
-            position="0,0,0"
-            munitionType="FusionMunition"
-            bulletLoadingTime="0.3"
-            magazineLoadingTime="3"
-            speed="600"
-            unlimitedMunition=true
-        />
-      </WeaponPack>
-    </weapons>
Index: code/trunk/data/levels/includes/weaponSettings2.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettings2.oxi	(revision 7801)
+++ 	(revision )
@@ -1,46 +1,0 @@
-    <weaponslots>
-      <WeaponSlot position="-15,-0.5,0" yaw=0 pitch=0 roll=0 />
-      <WeaponSlot position="15,-.5,0" yaw=0 pitch=0 roll=0 />
-      <WeaponSlot position="0,0,-45" yaw=0 pitch=0 roll=0 />
-    </weaponslots>
-    <weaponsets>
-      <WeaponSet firemode=0 />
-      <WeaponSet firemode=1 />
-    </weaponsets>
-    <weapons>
-      <WeaponPack>
-        <links>
-          <DefaultWeaponmodeLink firemode=0 weaponmode=0 />
-          <DefaultWeaponmodeLink firemode=1 weaponmode=1 />
-        </links>
-        <Weapon>
-          <attached>
-            <Model mesh="hs-w01.mesh" roll="195"/>
-            <Model mesh="hs-w01s.mesh" roll="195" position="0.1,-0.5,0"/>
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0 material="Flares/point_lensflare" muzzleoffset="-2,-0.2,-20" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 material="Flares/point_lensflare" muzzleoffset="2,0.2,-20" />
-          <LaserFire mode=1 damage=1 munitionpershot=0 reloadtime=1 muzzleoffset="0,5,0" />
-          <LaserFire mode=1 damage=1 munitionpershot=0 reloadtime=1 muzzleoffset="0,-5,0" />
-        </Weapon>
-        <Weapon>
-          <attached>
-            <Model mesh="hs-w01.mesh" roll="165"/>
-            <Model mesh="hs-w01s.mesh" roll="165" position="-0.1,-0.5,0"/>
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare"muzzleoffset="2,-0.2,-20" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 material="Flares/point_lensflare" muzzleoffset="-2,0.2,-20" />
-          <!--LaserFire mode=0 munitionpershot=0 muzzleoffset="0,0,-25" /-->
-          <LaserFire mode=1 damage=1 munitionpershot=0 reloadtime=1 muzzleoffset="0,5,0" />
-          <LaserFire mode=1 damage=1 munitionpershot=0 reloadtime=1 muzzleoffset="0,-5,0" />
-        </Weapon>
-      </WeaponPack>
-      <WeaponPack>
-        <links>
-          <DefaultWeaponmodeLink firemode=1 weaponmode=0 />
-        </links>
-        <Weapon>
-          <EnergyDrink mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare"muzzleoffset="2,-0.2,-20" />
-        </Weapon>
-      </WeaponPack>
-    </weapons>
Index: code/trunk/data/levels/includes/weaponSettings3.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettings3.oxi	(revision 7801)
+++ 	(revision )
@@ -1,53 +1,0 @@
-    <weaponslots>
-      <WeaponSlot position="-15.0,-1.5,0" />
-      <WeaponSlot position=" 15.0,-1.5,0" />
-      <WeaponSlot position="    0,   0,0" />
-    </weaponslots>
-    <weaponsets>
-      <WeaponSet firemode=0 />
-      <WeaponSet firemode=1 />
-      <WeaponSet firemode=2 />
-      <WeaponSet firemode=3 />
-    </weaponsets>
-    <weapons>
-      <WeaponPack>
-        <links>
-          <DefaultWeaponmodeLink firemode=0 weaponmode=0 />
-          <DefaultWeaponmodeLink firemode=1 weaponmode=1 />
-          <DefaultWeaponmodeLink firemode=2 weaponmode=2 />
-          <DefaultWeaponmodeLink firemode=3 weaponmode=3 />
-        </links>
-        <Weapon>
-          <attached>
-            <Model mesh="LightningGun.mesh" pitch="100" roll="90" yaw="90" position="0,-1.3,0" />
-            <Model mesh="LightningGun-s.mesh" pitch="78" roll="90" yaw="90" position="0.2,-1.3,0" />
-            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-76" yaw="-90" position="-1.5,1,0.3" scale=0.6 />
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" />
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
-        </Weapon>
-        <Weapon>
-          <attached>
-            <Model mesh="LightningGun.mesh" pitch="103" roll="90" yaw="90" position="0,-1.35,0" />
-            <Model mesh="LightningGun-s.mesh" pitch="103" roll="90" yaw="90" position="0.2,-1.35,0" />
-            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 />
-          </attached>
-          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" />
-          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" />
-          <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
-        </Weapon>
-        <Weapon>
-          <SimpleRocketFire mode=2 muzzleoffset="0,0,0" damage=50 />
-          <RocketFire mode=3 muzzleoffset="0,0,0" damage=100 />
-        </Weapon>
-      </WeaponPack>
-      <WeaponPack>
-        <links>
-          <DefaultWeaponmodeLink firemode=1 weaponmode=0 />
-        </links>
-        <!--Weapon>
-          <EnergyDrink mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare"muzzleoffset="2,-0.2,-1" />
-        </Weapon-->
-      </WeaponPack>
-    </weapons>
Index: code/trunk/data/levels/includes/weaponSettingsAssff.oxi
===================================================================
--- code/trunk/data/levels/includes/weaponSettingsAssff.oxi	(revision 7845)
+++ code/trunk/data/levels/includes/weaponSettingsAssff.oxi	(revision 7845)
@@ -0,0 +1,53 @@
+    <weaponslots>
+      <WeaponSlot position="-15.0,-1.5,0" />
+      <WeaponSlot position=" 15.0,-1.5,0" />
+      <WeaponSlot position="    0,   0,0" />
+    </weaponslots>
+    <weaponsets>
+      <WeaponSet firemode=0 />
+      <WeaponSet firemode=1 />
+      <WeaponSet firemode=2 />
+      <WeaponSet firemode=3 />
+    </weaponsets>
+    <weapons>
+      <WeaponPack>
+        <links>
+          <DefaultWeaponmodeLink firemode=0 weaponmode=0 />
+          <DefaultWeaponmodeLink firemode=1 weaponmode=1 />
+          <DefaultWeaponmodeLink firemode=2 weaponmode=2 />
+          <DefaultWeaponmodeLink firemode=3 weaponmode=3 />
+        </links>
+        <Weapon>
+          <attached>
+            <Model mesh="LightningGun.mesh" pitch="100" roll="90" yaw="90" position="0,-1.3,0" />
+            <Model mesh="LightningGun-s.mesh" pitch="78" roll="90" yaw="90" position="0.2,-1.3,0" />
+            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-76" yaw="-90" position="-1.5,1,0.3" scale=0.6 />
+          </attached>
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 0.1, 1.6,-2" />
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-1.6, 1.3,-2" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
+        </Weapon>
+        <Weapon>
+          <attached>
+            <Model mesh="LightningGun.mesh" pitch="103" roll="90" yaw="90" position="0,-1.35,0" />
+            <Model mesh="LightningGun-s.mesh" pitch="103" roll="90" yaw="90" position="0.2,-1.35,0" />
+            <Model mesh="hs-w01_reduced.mesh" roll="90" pitch="-104" yaw="-90" position="0,1.3,0.3" scale=0.6 />
+          </attached>
+          <HsW01 mode=0 munitionpershot=0 delay=0     damage=3.14159 material="Flares/point_lensflare" muzzleoffset=" 1.6, 1.3, -2.0" />
+          <HsW01 mode=0 munitionpershot=0 delay=0.125 damage=3.14159 material="Flares/point_lensflare" muzzleoffset="-0.1, 1.6, -2.0" />
+          <LightningGun mode=1 muzzleoffset="0,0,0" damage=23 />
+        </Weapon>
+        <Weapon>
+          <SimpleRocketFire mode=2 muzzleoffset="0,0,0" damage=50 />
+          <RocketFire mode=3 muzzleoffset="0,0,0" damage=100 />
+        </Weapon>
+      </WeaponPack>
+      <WeaponPack>
+        <links>
+          <DefaultWeaponmodeLink firemode=1 weaponmode=0 />
+        </links>
+        <!--Weapon>
+          <EnergyDrink mode=0 munitionpershot=0 delay=0  material="Flares/point_lensflare"muzzleoffset="2,-0.2,-1" />
+        </Weapon-->
+      </WeaponPack>
+    </weapons>
Index: code/trunk/data/levels/templates/spaceshipAssff.oxt
===================================================================
--- code/trunk/data/levels/templates/spaceshipAssff.oxt	(revision 7801)
+++ code/trunk/data/levels/templates/spaceshipAssff.oxt	(revision 7845)
@@ -35,5 +35,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettings3.oxi")
+  include("includes/weaponSettingsAssff.oxi")
 ?>
   </SpaceShip>
Index: code/trunk/data/levels/theTimeMachine.oxw
===================================================================
--- code/trunk/data/levels/theTimeMachine.oxw	(revision 7801)
+++ code/trunk/data/levels/theTimeMachine.oxw	(revision 7845)
@@ -53,5 +53,5 @@
     </collisionShapes>
 <?lua
-  include("includes/weaponSettings3.oxi")
+  include("includes/weaponSettingsAssff.oxi")
 ?>
   </SpaceShip>