Index: /code/trunk/src/modules/weapons/WeaponsPrereqs.h
===================================================================
--- /code/trunk/src/modules/weapons/WeaponsPrereqs.h	(revision 7845)
+++ /code/trunk/src/modules/weapons/WeaponsPrereqs.h	(revision 7846)
@@ -71,4 +71,5 @@
     class LaserMunition;
     class ReplenishingMunition;
+    class RocketMunition;
 
     // projectiles
Index: /code/trunk/src/modules/weapons/munitions/CMakeLists.txt
===================================================================
--- /code/trunk/src/modules/weapons/munitions/CMakeLists.txt	(revision 7845)
+++ /code/trunk/src/modules/weapons/munitions/CMakeLists.txt	(revision 7846)
@@ -3,3 +3,4 @@
   LaserMunition.cc
   FusionMunition.cc
+  RocketMunition.cc
 )
Index: /code/trunk/src/modules/weapons/munitions/RocketMunition.cc
===================================================================
--- /code/trunk/src/modules/weapons/munitions/RocketMunition.cc	(revision 7846)
+++ /code/trunk/src/modules/weapons/munitions/RocketMunition.cc	(revision 7846)
@@ -0,0 +1,51 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "RocketMunition.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    CreateFactory(RocketMunition);
+
+    RocketMunition::RocketMunition(BaseObject* creator) : Munition(creator)
+    {
+        RegisterObject(RocketMunition);
+
+        this->maxMunitionPerMagazine_ = 1;
+        this->maxMagazines_ = 30;
+        this->magazines_ = 10;
+
+        this->bUseSeparateMagazines_ = false;
+        this->bStackMunition_ = true;
+        this->reloadTime_ = 0.5f;
+
+        this->bAllowMunitionRefilling_ = false;
+        this->bAllowMultiMunitionRemovementUnderflow_ = false;
+    }
+}
Index: /code/trunk/src/modules/weapons/munitions/RocketMunition.h
===================================================================
--- /code/trunk/src/modules/weapons/munitions/RocketMunition.h	(revision 7846)
+++ /code/trunk/src/modules/weapons/munitions/RocketMunition.h	(revision 7846)
@@ -0,0 +1,45 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _RocketMunition_H__
+#define _RocketMunition_H__
+
+#include "weapons/WeaponsPrereqs.h"
+#include "weaponsystem/Munition.h"
+
+namespace orxonox
+{
+    class _WeaponsExport RocketMunition : public Munition
+    {
+        public:
+            RocketMunition(BaseObject* creator);
+            virtual ~RocketMunition() {}
+    };
+}
+
+#endif /* _RocketMunition_H__ */
Index: /code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 7845)
+++ /code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 7846)
@@ -51,5 +51,5 @@
         this->speed_ = 500;
 
-        this->setMunitionName("LaserMunition");
+        this->setMunitionName("RocketMunition");
         // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
     }
Index: /code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.cc
===================================================================
--- /code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 7845)
+++ /code/trunk/src/modules/weapons/weaponmodes/SimpleRocketFire.cc	(revision 7846)
@@ -53,6 +53,6 @@
         this->speed_ = 500;
 
-            this->setMunitionName("TargetSeeking Rockets");
-            this->setDefaultSoundWithVolume("sounds/Rocket_launch.ogg",0.4f);
+        this->setMunitionName("RocketMunition");
+        this->setDefaultSoundWithVolume("sounds/Rocket_launch.ogg",0.4f);
         // The firing sound of the Rocket is played in Rocket.cc (because of OpenAl sound positioning)
     }